var ExtractionStartListRemoval = function()
{
	var exreg = {};
	var debug = 0;

	var extraItemsList = [];
	var qiacubeSortedPrefixes = 'BCADEFGHIJKLMNOPQRSTUVWXYZ';
	var qiacubeDateIsAfterIsolationDate = true;
	var qiacubeRunNoIsValid = false;
	var qiacubePositionsAreValid = false;
	var counterBalanceInfoRow = false;
	var createdRna = [];
	
	// Page initialization
	exreg.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', exreg.validateStep1);

		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', exreg.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', exreg.validateStep2);
		
		Events.addEventHandler('isolationDate', 'change', Wizard.validateDate);
		Events.addEventHandler('qiacubeDate', 'change', Wizard.validateDate);
		Events.addEventHandler('isolationDate', 'change', exreg.qiacubeDateOnChange);
		Events.addEventHandler('qiacubeDate', 'change', exreg.qiacubeDateOnChange);
		Events.addEventHandler('qiacubeRunNo', 'change', exreg.qiacubeRunNoOnChange);

		// Step 3
		Events.addEventHandler('step-3', 'wizard-initialize', exreg.initializeStep3);
		Events.addEventHandler('step-3', 'wizard-validate', exreg.validateStep3);

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', exreg.submit);

		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetUnprocessedStartItemLists';
		url += '&orderDesc=true';		
		Wizard.showLoadingAnimation('Loading unprocessed items...');
		Wizard.asyncJsonRequest(url, exreg.initializeStep1);
	}
	
	exreg.initializeStep1 = function(response)
	{
		var frm = document.forms['meludi'];
		var itemLists = response.itemLists;
		
		var startList = frm.startList;
		if (itemLists.length > 0)
		{
			for (var i=0; i < itemLists.length; i++)
			{
				var itemList = itemLists[i];
				var name = (i+1) + ': ' + Strings.encodeTags(itemList.name);
				if (itemList.sourceItemNames)
				{
					name += ' -- (';
					name += itemList.numMeludiItems;
					name += ' + ' + itemList.numExtraItems;
					name += ')';
				}
				if (itemList.extractionDate)
				{
					name += ' -- [' + exreg.asDate(itemList.extractionDate) + ']';
				}
				var selected = i == (itemLists.length - 1);
				var option = new Option(name, itemList.id, selected, selected);
				option.itemList = itemList;
				startList.options[startList.length] = option;
			}
			startList.options[0].selected = true;
		}
		else
		{
			Wizard.setFatalError('No start lists available.');
			return;
		}
		Doc.show('step-1');
		Doc.show('gonext');
		Doc.hide('extractSourceItems');
	}

	exreg.validateStep1 = function(event)
	{
		var frm = document.forms['meludi'];
		var startList = null;
		for (var i = 0; i < frm.startList.length; i++)
		{
			if (frm.startList[i].selected)
			{
				startList = frm.startList[i];
			}
		}
		if (startList == null)
		{
			event.preventDefault();
		}
	}
	
	exreg.initializeStep2 = function()
	{
		var frm = document.forms['meludi'];
		var startItemList = null;
		for (var i = 0; i < frm.startList.length; i++)
		{
			if (frm.startList[i].selected)
			{
				startItemList = frm.startList[i];
			}
		}
		if (startItemList == null)
		{
			event.preventDefault();
		}

		frm.startList.disabled = true;

		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		Doc.show('gonext');
		Doc.hide('extractionProtocolId');

		frm.isolationDate.focus();
		Events.sendChangeEvent('isolationDate');
		Events.sendChangeEvent('qiacubeDate');

		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetSourceItemListFromStartItemList';
		url += '&startItemListId='+startItemList.value;
		Wizard.asyncJsonRequest(url, exreg.sourceItemListLoaded);
	}

	exreg.sourceItemListLoaded = function(response)
	{
		var frm = document.forms['meludi'];

		var startItemList = response.startitemlist;
		var specimens = response.specimens;
		var rnas = response.rnas;
		var dnas = response.dnas;
		var items = response.items;
		var startListIsProcessed = false;
		extraItemsList = response.extraitems;

		if (startItemList)
		{
			// Extraction parameters
			frm.startListName.value = startItemList.name;
			// Extraction parameters
			frm.isolationDate.value = startItemList.isolationDate;
			frm.extractionOperator.value = startItemList.extractionOperator;
			frm.extractionProtocolId.value = startItemList.extractionProtocolId;
			frm.extractionProtocolName.value = startItemList.extractionProtocolName;

			// QIAcube parameters
			frm.qiacubeDate.value = startItemList.qiacubeDate;
			frm.qiacubeOperator.value = startItemList.qiacubeOperator;
			frm.qiacubePrimaryPrefix.value = startItemList.qiacubePrimaryPrefix;
			frm.qiacubeSecondaryPrefix.value = startItemList.qiacubeSecondaryPrefix;
			frm.qiacubeRunNo.value = startItemList.qiacubeRunNo;

			// Specimen reagents
			frm.xyleneSpecimen.value = startItemList.xyleneSpecimen;
			frm.etoh995Specimen.value = startItemList.etoh995Specimen;
			frm.allPrepFfpeKit.value = startItemList.allPrepFfpeKit;
			frm.bufferPkdSpecimen.value = startItemList.bufferPkdSpecimen;
			frm.bufferAtlSpecimen.value = startItemList.bufferAtlSpecimen;
			frm.proteinaseKSpecimen.value = startItemList.proteinaseKSpecimen;
			frm.rnaseASpecimen.value = startItemList.rnaseASpecimen;

			// QIAcube reagents
			frm.etoh995.value = startItemList.etoh995;
			frm.bufferRlt.value = startItemList.bufferRlt;
			frm.bufferFrn.value = startItemList.bufferFrn;
			frm.bufferRpe.value = startItemList.bufferRpe;
			frm.bufferAl.value = startItemList.bufferAl;
			frm.bufferAw1.value = startItemList.bufferAw1;
			frm.bufferAw2.value = startItemList.bufferAw2;
			frm.bufferAte.value = startItemList.bufferAte;
			frm.bufferRdd.value = startItemList.bufferRdd;
			frm.rnaseFreeWater.value = startItemList.rnaseFreeWater;
			frm.dnaseMix.value = startItemList.dnaseMix;
			frm.rneasyMinEluteSpinColumn.value = startItemList.rneasyMinEluteSpinColumn;
			frm.qiaampMinEluteSpinColumn.value = startItemList.qiaampMinEluteSpinColumn;

			// Quality control reagents
			frm.kapaSybrFast.value = startItemList.kapaSybrFast;
			frm.qualityControlPrimersQcpRgt.value = startItemList.qualityControlPrimersQcpRgt;
			frm.qualityControlTemplateQct.value = startItemList.qualityControlTemplateQct;
			frm.qubitDnaHighSens.value = startItemList.qubitDnaHighSens;
			frm.qubitDnaBroadRange.value = startItemList.qubitDnaBroadRange;

			// Disable input fields

			// Extraction parameters
			frm.startListName.disabled = true;
			frm.isolationDate.disabled = true;
			frm.extractionOperator.disabled = true;
			frm.extractionProtocolName.disabled = true;

			// Specimen reagents
			frm.xyleneSpecimen.disabled = true;
			frm.etoh995Specimen.disabled = true;
			frm.allPrepFfpeKit.disabled = true;
			frm.bufferPkdSpecimen.disabled = true;
			frm.bufferAtlSpecimen.disabled = true;
			frm.proteinaseKSpecimen.disabled = true;
			frm.rnaseASpecimen.disabled = true;

			// QIAcube parameters
			frm.qiacubeDate.disabled = true;
			frm.qiacubeOperator.disabled = true;
			frm.qiacubePrimaryPrefix.disabled = true;
			frm.qiacubeSecondaryPrefix.disabled = true;
			frm.qiacubeRunNo.disabled = true;

			// QIAcube reagents
			frm.etoh995.disabled = true;
			frm.bufferRlt.disabled = true;
			frm.bufferFrn.disabled = true;
			frm.bufferRpe.disabled = true;
			frm.bufferAl.disabled = true;
			frm.bufferAw1.disabled = true;
			frm.bufferAw2.disabled = true;
			frm.bufferAte.disabled = true;
			frm.bufferRdd.disabled = true;
			frm.rnaseFreeWater.disabled = true;
			frm.dnaseMix.disabled = true;
			frm.rneasyMinEluteSpinColumn.disabled = true;
			frm.qiaampMinEluteSpinColumn.disabled = true;

			// Quality control reagents
			frm.kapaSybrFast.disabled = true;
			frm.qualityControlPrimersQcpRgt.disabled = true;
			frm.qualityControlTemplateQct.disabled = true;
			frm.qubitDnaHighSens.disabled = true;
			frm.qubitDnaBroadRange.disabled = true;
		}

		var sourceItemList = frm.extractSourceItems;
		if (items.length > 0)
		{
			var numItems = items.length;
			for (var i=0; i < items.length; i++)
			{
				var item = items[i];
				var name = (i+1) + ': ' + Strings.encodeTags(item.name);
				if (item.bioWell)
				{
					name += ' -- ' + Strings.encodeTags(item.bioWell.bioPlate.name + ' (' + item.bioWell.location+')');
				}
				var selected = true;
				// Identification of item via id works here as specimens and extracts
				// are stored in the same database table using discriminators, and are
				// therefore guaranteed to not have the same id value as another item in the table.
				var option = new Option(name, item.id, selected, selected);
				option.item = item;
				sourceItemList.options[sourceItemList.length] = option;
			}
		}
		else
		{
			Wizard.setFatalError('No items available for processing.');
			return;
		}
	}

	exreg.qiacubeDateOnChange = function()
	{
		var frm = document.forms['meludi'];
		
		var isolationDateIsValid = Wizard.isValid('isolationDate');
		var qiacubeDateIsValid = Wizard.isValid('qiacubeDate');
		
		if (!isolationDateIsValid || !qiacubeDateIsValid) return;

		var isolationDate = Dates.parseString(frm.isolationDate.value, 'yyyyMMdd');
		var qiacubeDate = Dates.parseString(frm.qiacubeDate.value, 'yyyyMMdd');
		if (isolationDate > qiacubeDate)
		{
			Wizard.setInputStatus('qiacubeDate', 'invalid', 'QIAcube date is before isolation date');
			qiacubeDateIsAfterIsolationDate = false;
			return;
		}

		qiacubeDateIsAfterIsolationDate = true;
		
		Wizard.setInputStatus('qiacubeDate', 'valid');
		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetNextQiacubeRunNo&qiacubeDate='+encodeURIComponent(frm.qiacubeDate.value);
		Wizard.showLoadingAnimation('Loading Qiacube run number...');
		Wizard.asyncJsonRequest(url, exreg.gotNextRunNumber);
	}

	exreg.gotNextRunNumber = function(response)
	{
		var frm = document.forms['meludi'];
		frm.qiacubeRunNo.value = response.nextQiacubeRunNo;
		Events.sendChangeEvent('qiacubeRunNo');
	}

	exreg.qiacubeRunNoOnChange = function()
	{
		var frm = document.forms['meludi'];
		var runNumber = frm.qiacubeRunNo.value;
		qiacubeRunNoIsValid = false;

		if (runNumber == '')
		{
			Wizard.setInputStatus('qiacubeRunNo', 'invalid', 'Missing');
			return;
		}
		if (!(parseInt(runNumber, 10) >= 1))
		{
			Wizard.setInputStatus('qiacubeRunNo', 'invalid', 'Must be at least 1');
			return;		
		}
		
		Wizard.setInputStatus('qiacubeRunNo', 'valid');
		qiacubeRunNoIsValid = true;
	}

	exreg.validateStep2 = function(event)
	{
		var valid = true;
		valid &= Wizard.isValid('isolationDate');
		valid &= Wizard.isValid('qiacubeDate');
		valid &= qiacubeRunNoIsValid;
		
		if (!valid) event.preventDefault();
	}

	exreg.initializeStep3 = function()
	{
		var frm = document.forms['meludi'];
		var startItemList = null;
		for (var i = 0; i < frm.startList.length; i++)
		{
			if (frm.startList[i].selected)
			{
				startItemList = frm.startList[i];
			}
		}
		if (startItemList == null)
		{
			event.preventDefault();
		}
		var startListName = frm.startListName.value;
		Doc.element('detailsStartListName').innerHTML = '<b>Start list: ' + startListName + '</b>';
		qiacubeSortedPrefixes = exreg.getQiacubeSortedPrefixes();
		
		var html = '<table id="detailsTable" class="step-form">';
		// First header row
		html += '<thead>';
		html += '<tr>';
		html += '<th>Extract</th>';
		html += '<th class="dottedleft">QIAcube</th>';
		html += '<th colspan="1" class="dottedleft"></th>';
		html += '<th colspan="1" class="dottedleft">NanoDrop</th>';
		html += '<th colspan="1" class="dottedleft">RNA</th>';
		html += '<th colspan="1" class="dottedleft">DNA</th>';
		html += '<th class="dottedleft comment">Comment</th>';
		html += '<th></th>';
		html += '</tr>';
		// Second header row
		html += '<tr>';
		html += '<th>source item</th>';
		html += '<th class="dottedleft">position</th>';
		html += '<td class="dottedleft">Storage</td>';
		html += '<th class="dottedleft">Plate Pos.</th>';
		html += '<th class="dottedleft">Plate Pos.</th>';
		html += '<th class="dottedleft">Plate Pos.</th>';
		html += '<td class="dottedleft comment"></td>';
		html += '<td></td>';
		html += '</tr>';
		// Third header row
		html += '<tr>';
		html += '<th></th>';
		html += '<th class="dottedleft"></th>';
		html += '<td class="dottedleft">box</td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft comment"></td>';
		html += '<td></td>';
		html += '</tr>';
		html += '</thead>';
		html += '<tbody>';

		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numSpecimenItems = exreg.getNumberOfSpecimenItems();
		var numRnaItems = exreg.getNumberOfRnaItems();
		var numDnaItems = exreg.getNumberOfDnaItems();
		var numNanoDropItems = numSpecimenItems + numRnaItems;
		var numQiacubeItems = numSpecimenItems;
		var totNumItems = numItems;
		var itemNo = 0;
		var qiacubeItemNo = 0;
		// Set default values for DNA/RNA extraction
		for (var i = 0; i < totNumItems; i++)
		{
			itemNo++;
			var item = null;
			var storageBox = '-';
			var rnaStorageBox = '-';
			var dnaStorageBox = '-';
			item = selItemsList[i];
			var qiacubePos = null;
			if (ExtractUtils.isSpecimen(item))
			{
				qiacubeItemNo++;
				qiacubePos = ExtractUtils.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo, qiacubeSortedPrefixes);
			}
			item.qiacubePosition = qiacubePos;
			item.originalQiacubePosition = qiacubePos;
				
			var rna = {};
			var dna = {};
			// RNA
			rna.name = item.name + '.r';
			// DNA
			dna.name = item.name + '.d';
			if (!item.rna)
			{
				item.rna = rna;
			}
			if (!item.dna)
			{
				item.dna = dna;
			}

			// Input extract source item specimen/RNA/DNA
			if (item.bioWell != null)
			{
				storageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
			}
			// RNA extract from specimen
			if (item.rna && item.rna.bioWell)
			{
				rnaStorageBox = Strings.encodeTags(item.rna.bioWell.bioPlate.name + '[' + item.rna.bioWell.location + ']');
			}
			// DNA extract from specimen
			if (item.dna && item.dna.bioWell)
			{
				dnaStorageBox = Strings.encodeTags(item.dna.bioWell.bioPlate.name + '[' + item.dna.bioWell.location + ']');
			}
			// Input RNA item storage location should be displayed in the RNA extract storage location column
			if (ExtractUtils.isRna(item) && item.bioWell != null)
			{
				rnaStorageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
			}
			// Input DNA item storage location should be displayed in the DNA extract storage location column
			if (ExtractUtils.isDna(item) && item.bioWell != null)
			{
				dnaStorageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
			}
			html += '<tr class="highlight">';
			html += '<th>' + Strings.encodeTags(item.name) + '</th>';
			html += '<td id="qiacubePosition'+i+'" class="dottedleft"></td>';
			html += '<td class="dottedleft">'+storageBox+'</td>';
			html += '<td id="rnaPos'+i+'" class="dottedleft"></td>';
			html += '<td id="rnaPlatePos'+i+'" class="dottedleft">'+rnaStorageBox+'</td>';
			html += '<td id="dnaPlatePos'+i+'" class="dottedleft">'+dnaStorageBox+'</td>';
			html += '<td id="comments'+i+'" class="dottedleft comment"></td>';
			html += '</tr>';
		}
		if (numQiacubeItems == 1 || numQiacubeItems == 11 || numQiacubeItems == 23)
		{
			// Add extra row for counterbalance in QIAcube
			counterBalanceInfoRow = true;
			var i = numItems;
			var qiacubePos = ExtractUtils.getDetailedQiaCubePosition(numQiacubeItems + 1, numQiacubeItems + 1, qiacubeSortedPrefixes);
				
			html += '<tr class="highlight">';
			html += '<th>' + Strings.encodeTags('COUNTER-BALANCE') + '</th>';
			html += '<td id="qiacubePosition'+i+'" class="dottedleft">'+qiacubePos+'</td>';
			html += '<td class="dottedleft">-</td>';
			html += '<td id="rnaPos'+i+'" class="dottedleft">-</td>';
			html += '<td id="rnaPlatePos'+i+'" class="dottedleft">-</td>';
			html += '<td id="dnaPlatePos'+i+'" class="dottedleft">-</td>';
			html += '<td id="comments'+i+'" class="dottedleft comment">Reminder to use counterbalance</td>';
			html += '</tr>';				
		}
		html += '</tbody>';
		html += '</table>';
		Doc.element('detailsSection').innerHTML = html;

		Wizard.setCurrentStep(3);

		Doc.hide('sampleIdFilesSection');

		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetSourceItemListFromStartItemList';
		url += '&startItemListId='+startItemList.value;
		url += '&includeSpecimenExtracts=true';
		Wizard.asyncJsonRequest(url, exreg.initializeStep3b);
	}
		
	exreg.initializeStep3b = function(response)
	{
		var frm = document.forms['meludi'];
		var numQiacubeItems = exreg.getNumberOfSpecimenItems();
		qiacubeSortedPrefixes = exreg.getQiacubeSortedPrefixes();
		var qiacubeItemNo = 0;

		var itemNameNanoDropPosJson = exreg.createItemNameNanoDropPosJson();

		// Re-load source item list, as items now have more info attached
		var items = response.items;
		var sourceItemList = frm.extractSourceItems;
		if (items.length > 0)
		{
			var numItems = items.length;
			for (var i=0; i < items.length; i++)
			{
				var item = items[i];
				if (!item.rna)
				{
					var rna = {};
					// RNA
					rna.name = item.name + '.r';
					rna.well = null;
					item.rna = rna;
				}
				if (!item.dna)
				{
					var dna = {};
					// DNA
					dna.name = item.name + '.d';
					item.dna = dna;
				}
				// Set RNA well
				item.rna.nanoDropWell = null;
				if (ExtractUtils.isSpecimen(item) || ExtractUtils.isRna(item))
				{
					var nanoDropPos = itemNameNanoDropPosJson[item.name];
					if (nanoDropPos)
					{
						item.rna.nanoDropWell = nanoDropPos;
					}
				}
				var selected = true;
				// Identification of item via id works here as specimens and extracts
				// are stored in the same database table using discriminators, and are
				// therefore guaranteed to not have the same id value as another item in the table.
				var option = new Option(name, item.id, selected, selected);
				option.item = item;
				sourceItemList.options[i] = option;
			}
		}
		else
		{
			Wizard.setFatalError('No items available for processing.');
			return;
		}
		
		exreg.updateDetailsTable();
		
		Wizard.setCurrentStep(3);

		Doc.show('gocancel');
		Doc.show('goregister');
		Wizard.showGoNextConfirmation(true, 'Check to verify removal of start list.');
		
		Wizard.keepSessionAlive();
	}

	exreg.submit = function()
	{
		var frm = document.forms['meludi'];
		
		var submitInfo = {};
		submitInfo.items = [];
		submitInfo.extraItems = [];

		var startItemList = null;
		for (var i = 0; i < frm.startList.length; i++)
		{
			if (frm.startList[i].selected)
			{
				startItemList = frm.startList[i];
			}
		}

		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var totNumItems = numItems;
		for (var i = 0; i < totNumItems; i++)
		{
			var item = null;
			if (i < numItems)
			{
				item = selItemsList[i];
				submitInfo.items[submitInfo.items.length] = item;
			}
		}
		
		// Extraction
		submitInfo.startListName = frm.startListName.value;
		submitInfo.isolationDate = frm.isolationDate.value;
		submitInfo.extractionOperator = frm.extractionOperator.value;

		// QIAcube
		submitInfo.qiacubeDate = frm.qiacubeDate.value;
		submitInfo.qiacubeOperator = frm.qiacubeOperator.value;
		submitInfo.qiacubePrimaryPrefix = frm.qiacubePrimaryPrefix.value;
		submitInfo.qiacubeSecondaryPrefix = frm.qiacubeSecondaryPrefix.value;
		submitInfo.qiacubeRunNo = parseInt(frm.qiacubeRunNo.value, 10);
		submitInfo.allPrepFfpeKit = frm.allPrepFfpeKit.value;

		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=RemoveStartItemList';
		url += '&startItemListId='+startItemList.value;
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, exreg.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	exreg.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	exreg.createItemNameNanoDropPosJson = function()
	{
		var frm = document.forms['meludi'];

		qiacubeSortedPrefixes = exreg.getQiacubeSortedPrefixes();
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numSpecimenItems = exreg.getNumberOfSpecimenItems();
		var numQiacubeItems = numSpecimenItems;
		var totNumItems = numItems;
		var itemNo = 0;
		qiacubeItemNo = 0;
		var nanoDropItemNo = 0;
		var rnaItemNo = 0;
		var intNanoDropPlatePosition = 0;
		// Store NanoDrop positions as JSON object with item names as keys
		var nanoDropJsonStr = '{';
		for (var i = 0; i < totNumItems; i++)
		{
			itemNo++;
			var item = null;
			var qiacubePos = null;
			item = selItemsList[i];
			if (ExtractUtils.isSpecimen(item))
			{
				qiacubeItemNo++;
				intNanoDropPlatePosition = qiacubeItemNo;
			}
			if (ExtractUtils.isRna(item))
			{
				rnaItemNo++;
				intNanoDropPlatePosition = numSpecimenItems + rnaItemNo;
			}
			
			// Calculate NanoDrop well from Qiacube position
			var row;
			var col;
			// Specimens from up to two QIAcube instruments and input RNA items placed on one NanoDrop plate
			if (intNanoDropPlatePosition > 16)
			{
				// (17 - 24) NanoDrop plate for secondary QIAcube, positions A3 - H3
				row = intNanoDropPlatePosition - 17;
				col = 3;
			}
			else if (intNanoDropPlatePosition > 8)
			{
				// ( 9 - 12) NanoDrop plate for primary QIAcube, positions A2 - D2
				// (13 - 16) NanoDrop plate for secondary QIAcube, positions E2 - H2
				row = intNanoDropPlatePosition - 9;
				col = 2;
			}
			else if (intNanoDropPlatePosition > 0)
			{
				// ( 1 -  8) NanoDrop plate for primary QIAcube, positions A1 - H1
				row = intNanoDropPlatePosition - 1;
				col = 1;
			}
			var nanoDropWell = Meludi.wellToAlpha(row) + col;
			// Store NanoDrop position as JSON object with item name as key
			if (nanoDropItemNo > 0)
			{
				nanoDropJsonStr += ',';
			}
			nanoDropJsonStr += '"' + item.name + '":"' + nanoDropWell + '"';
			nanoDropItemNo++;
		}
		nanoDropJsonStr += '}';
		return nanoDropJsonStr;
	}

	exreg.getQiacubeSortedPrefixes = function()
	{
		var frm = document.forms['meludi'];
		var primaryQiacubePrefix = frm.qiacubePrimaryPrefix.value;
		var secondaryQiacubePrefix = frm.qiacubeSecondaryPrefix.value;

		// Get string of current QIAcube prefixes in order
		var sortedPrefixes = ExtractUtils.getQiacubeSortedPrefixes(primaryQiacubePrefix, secondaryQiacubePrefix);
		return sortedPrefixes;
	}

	exreg.getSelectedItemsList = function()
	{
		var frm = document.forms['meludi'];

		// Get number of selected extract source items
		var numItems = 0;
		var selItemsList = [];
		for (var i = 0; i < frm.extractSourceItems.length; i++)
		{
			if (frm.extractSourceItems[i].selected)
			{
				if (frm.extractSourceItems[i].item != null)
				{
					selItemsList[numItems] = frm.extractSourceItems[i].item;
					numItems++;
				}
			}
		}
		return selItemsList;
	}

	exreg.getNumberOfSpecimenItems = function()
	{
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numSpecimen = 0;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (ExtractUtils.isSpecimen(item))
			{
				numSpecimen++;
			}
		}
		return numSpecimen;
	}
	
	exreg.getNumberOfRnaItems = function()
	{
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numRna = 0;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (ExtractUtils.isRna(item))
			{
				numRna++;
			}
		}
		return numRna;
	}
	
	exreg.getNumberOfDnaItems = function()
	{
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numDna = 0;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (ExtractUtils.isDna(item))
			{
				numDna++;
			}
		}
		return numDna;
	}

	exreg.updateDetailsTable = function()
	{
		var frm = document.forms['meludi'];
		var hasQiacubePosition = [];
		var duplicatePosition = 0;

		qiacubeSortedPrefixes = exreg.getQiacubeSortedPrefixes();
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numSpecimenItems = exreg.getNumberOfSpecimenItems();
		var numRnaItems = exreg.getNumberOfRnaItems();
		var numDnaItems = exreg.getNumberOfDnaItems();
		var numNanoDropItems = numSpecimenItems + numRnaItems;
		var numQiacubeItems = numSpecimenItems;
		var totNumItems = numItems;
		// Get sorted list of used integer QIAcube positions for specimens, generalized for more than one QIAcube
		var specSortedIntQiacubePosition = [];
		var qiacubeItemNo = 0;
		for (var i = 0; i < totNumItems; i++)
		{
			var item = selItemsList[i];
			if (ExtractUtils.isSpecimen(item))
			{
				var qiacubePos = ExtractUtils.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo + 1, qiacubeSortedPrefixes);
				item.qiacubePosition = qiacubePos;
				var intQiacubePosition = ExtractUtils.getIntQiacubePosition(item.qiacubePosition, qiacubeSortedPrefixes);
				specSortedIntQiacubePosition[qiacubeItemNo] = intQiacubePosition;
				qiacubeItemNo++;
			}
		}
		// Sort for ascending integer values
		specSortedIntQiacubePosition.sort(function(a,b){return a-b});
		var rnaItemNo = 0;
		var qiacubeItemNo = 0;
		// Set default values for DNA/RNA extraction
		for (var i = 0; i < totNumItems; i++)
		{
			var rnaStorageBox = '-';
			var dnaStorageBox = '-';
			var item = null;
			item = selItemsList[i];
			var qiacubePos = null;
			if (ExtractUtils.isSpecimen(item))
			{
				qiacubeItemNo++;
				qiacubePos = ExtractUtils.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo, qiacubeSortedPrefixes);
				item.qiacubePosition = qiacubePos;
			}
			item.originalQiacubePosition = qiacubePos;

			// RNA extract from specimen
			if (item.rna && item.rna.bioWell)
			{
				rnaStorageBox = Strings.encodeTags(item.rna.bioWell.bioPlate.name + '[' + item.rna.bioWell.location + ']');
			}
			// DNA extract from specimen
			if (item.dna && item.dna.bioWell)
			{
				dnaStorageBox = Strings.encodeTags(item.dna.bioWell.bioPlate.name + '[' + item.dna.bioWell.location + ']');
			}
			// Input RNA item storage location should be displayed in the RNA extract storage location column
			if (ExtractUtils.isRna(item) && item.bioWell != null)
			{
				rnaStorageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
			}
			// Input DNA item storage location should be displayed in the DNA extract storage location column
			if (ExtractUtils.isDna(item) && item.bioWell != null)
			{
				dnaStorageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
			}
			if (Doc.element('qiacubePosition'+i))
			{
				Doc.element('qiacubePosition'+i).innerHTML = item.qiacubePosition;
				Doc.addOrRemoveClass('qiacubePosition'+i, 'nondefault', item.qiacubePosition != item.originalQiacubePosition);
			}

			var intQiacubePosition = ExtractUtils.getIntQiacubePosition(item.qiacubePosition, qiacubeSortedPrefixes);			
			if (intQiacubePosition != null)
			{
				if (hasQiacubePosition[intQiacubePosition])
				{
					duplicatePosition = intQiacubePosition;
				}
				else
				{
					hasQiacubePosition[intQiacubePosition] = true;
				}
			}
			var intNanoDropPlatePosition = intQiacubePosition;
			// Get integer NanoDrop position for specimens from index in sorted list of used integer QIAcube positions
			if (intQiacubePosition)
			{
				var sortIndex = -1;
				for (var j = 0; j < specSortedIntQiacubePosition.length; j++)
				{
					if (intQiacubePosition == specSortedIntQiacubePosition[j])
					{
						sortIndex = j;
					}
				}
				if (sortIndex > -1)
				{
					intNanoDropPlatePosition = sortIndex + 1;
				}
			}
			if (ExtractUtils.isRna(item))
			{
				rnaItemNo++;
				intNanoDropPlatePosition = numSpecimenItems + rnaItemNo;
			}
			
			// Calculate NanoDrop well from Qiacube position
			var row;
			var col;
			// Specimens from up to two QIAcube instruments and input RNA items placed on one NanoDrop plate
			if (intNanoDropPlatePosition > 16)
			{
				// (17 - 24) NanoDrop plate for secondary QIAcube, positions A3 - H3
				row = intNanoDropPlatePosition - 17;
				col = 3;
			}
			else if (intNanoDropPlatePosition > 8)
			{
				// ( 9 - 12) NanoDrop plate for primary QIAcube, positions A2 - D2
				// (13 - 16) NanoDrop plate for secondary QIAcube, positions E2 - H2
				row = intNanoDropPlatePosition - 9;
				col = 2;
			}
			else if (intNanoDropPlatePosition > 0)
			{
				// ( 1 -  8) NanoDrop plate for primary QIAcube, positions A1 - H1
				row = intNanoDropPlatePosition - 1;
				col = 1;
			}
			var nanoDropWell = Meludi.wellToAlpha(row) + col;
			if (i < numItems)
			{
			
				if (ExtractUtils.isSpecimen(item) || ExtractUtils.isRna(item))
				{
					item.rna.nanoDropWell = nanoDropWell;
				}
				else
				{
					if (item.dna)
					{
						//item.dna.well = null;
						item.rna.nanoDropWell = null;
					}					
				}

				if (Doc.element('rnaPlatePos'+i))
				{
					Doc.element('rnaPlatePos'+i).innerHTML = rnaStorageBox;
				}
				if (Doc.element('dnaPlatePos'+i))
				{
					Doc.element('dnaPlatePos'+i).innerHTML = dnaStorageBox;
				}
				if (item.rna)
				{
					if (Doc.element('rnaPos'+i))
					{
						Doc.element('rnaPos'+i).innerHTML = item.rna.nanoDropWell;
						Doc.addOrRemoveClass('rnaPos'+i, 'nondefault', item.qiacubePosition != item.originalQiacubePosition);
					}
				}
				else
				{
					if (Doc.element('rnaPos'+i))
					{
						if (ExtractUtils.isRna(item))
						{
							Doc.element('rnaPos'+i).innerHTML = nanoDropWell;
						}						
						if (ExtractUtils.isDna(item))
						{
							Doc.element('rnaPos'+i).innerHTML = null;
						}						
					}
				}
				var cmnt = Doc.element('comments'+i);
				var tooltip = [];
				var comment = [];
				// Update comment data with description data
				if (item.description || item.dna.description || item.rna.description)
				{
					if (ExtractUtils.isSpecimen(item))
					{					
						if (item.description)
						{
							if (!item.comment)
							{
								item.comment = item.description;
							}
						}
						if (item.rna.description)
						{
							if (!item.rna.comment)
							{
								item.rna.comment = item.rna.description;
							}
						}
						if (item.dna.description)
						{
							if (!item.dna.comment)
							{
								item.dna.comment = item.dna.description;
							}
						}
					}
					if (ExtractUtils.isRna(item))
					{					
						if (item.description)
						{
							if (!item.rna.comment)
							{
								item.rna.comment = item.description;
							}
						}
						if (item.rna.description)
						{
							if (!item.rna.comment)
							{
								item.rna.comment = item.rna.description;
							}
						}
					}
					if (ExtractUtils.isDna(item))
					{					
						if (item.description)
						{
							if (!item.dna.comment)
							{
								item.dna.comment = item.description;
							}
						}
						if (item.dna.description)
						{
							if (!item.dna.comment)
							{
								item.dna.comment = item.dna.description;
							}
						}
					}
				}
				if (item.operatorDeliveryComment || item.comment || item.dna.comment || item.rna.comment)
				{
					// Display operator delivery comments directly in the comment field
					if (item.operatorDeliveryComment)
					{
						comment[0] = item.operatorDeliveryComment;
						tooltip[tooltip.length] = 'Op.Del.Cmt: ' + item.operatorDeliveryComment;
					}
					else
					{
						comment[0] = 'Yes';
					}
					if (item.comment) tooltip[tooltip.length] = 'Specimen: ' + item.comment;
					if (item.rna.comment) tooltip[tooltip.length] = 'RNA: ' + item.rna.comment;
					if (item.dna.comment) tooltip[tooltip.length] = 'DNA: ' + item.dna.comment;
				}

				if (cmnt)
				{				
					if (tooltip.length > 0)
					{
						cmnt.innerHTML = comment.join(', ');
						Doc.addClass(cmnt, 'nondefault');
						cmnt.title = tooltip.join('\n');
					}
					else
					{
						cmnt.innerHTML = '';
						Doc.removeClass(cmnt, 'nondefault');
						cmnt.title = null;
					}
				}
			}
		}
		
		if (duplicatePosition)
		{
			var duplicatePositionStr = ExtractUtils.getDetailedQiacubePosition(duplicatePosition, qiacubeSortedPrefixes);
			qiacubePositionsAreValid = false;
		}
		else
		{
			qiacubePositionsAreValid = true;
		}
	}

	exreg.validateStep3 = function(event)
	{
		var valid = true;
		valid &= qiacubePositionsAreValid;
		
		if (!valid) event.preventDefault();
	}

	// Format value as a date in format yyyy-mm-dd
	exreg.asDate = function(value)
	{
		if (!value) return '';
		if (value.length == 8)
		{
			value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
		}
		return value;
	}

	return exreg;
}();

Doc.onLoad(ExtractionStartListRemoval.initPage);

